diff --git a/statement.c b/statement.c
index 1b1980b..c900f29 100755
--- a/statement.c
+++ b/statement.c
@@ -1835,7 +1835,8 @@ SC_execute(StatementClass *self)
 	{
 		QResultClass *curres = SC_get_Curres(self);
 
-		if (NULL != curres)
+		if (NULL != curres &&
+		    curres->dataFilled)
 			useCursor = (NULL != QR_get_cursor(curres));
 	} 
 	/* issue BEGIN ? */
@@ -1913,13 +1914,19 @@ SC_execute(StatementClass *self)
 #endif /* BYPASS_ONESHOT_PLAN_EXECUTION */
 					case NAMED_PARSE_REQUEST:
 						use_extended_protocol = TRUE;
+						break;
 				}
 			}
-			if (!use_extended_protocol)
+			if (use_extended_protocol)
+				break;
+		case ONCE_DESCRIBED:
+			SC_forget_unnamed(self);
 			{
-				SC_forget_unnamed(self);
-				SC_set_Result(self, NULL); /* discard the parsed information */
+				QResultClass	*pres = SC_get_Result(self);
+				if (NULL != pres && NULL == QR_get_command(pres))
+					SC_set_Result(self, NULL); /* discard the parsed information */
 			}
+			break;
 	}
 	if (use_extended_protocol)
 	{
